* Test the FX object by running a report with and without it.

open database _samples + 'Data\TestData'
loListener = newobject('FXListener', home() + 'FFC\_ReportListener.vcx')
loListener.ListenerType = 1 && LISTENER_TYPE_PRV
report form Foreground object loListener

loListener.AddCollectionMember('SFFXRenderInForeground', ;
	'SFFXRenderInForeground.prg', '', .T., .T.)
report form Foreground object loListener

* The definition of the FX class.

define class SFFXRenderInForeground as FXAbstract of home() + ;
	'FFC\_ReportListener.vcx'
	dimension aForeground[1]
		&& an array of rendering information
	lSelfCall = .F.
		&& .T. if we're being called from ourselves (we call Render which calls
		&& us)
	
	function ApplyFX(toListener, ;
		tcMethodToken, ;
		tP1, ;
		tP2, ;
		tP3, ;
		tP4, ;
		tP5, ;
		tP6, ;
		tP7, ;
		tP8, ;
		tP9, ;
		tP10, ;
		tP11, ;
		tP12)
		local lnReturn, ;
			lnSession, ;
			lnSelect, ;
			lnCurrRecno, ;
			lnRecno, ;
			lnI, ;
			loForeground
		lnReturn = 0 && OUTPUTFX_BASERENDER_AFTERRESTORE
		do case

* Before the report runs, create an array of information about objects we'll
* process.

			case tcMethodToken = 'BEFOREREPORT'
				lnSession = set('DATASESSION')
				if toListener.FRXDataSession > -1
					set datasession to toListener.FRXDataSession
				endif toListener.FRXDataSession > -1
				lnSelect = select()
				select FRX
				lnCurrRecno = recno()
				scan for 'FOREGROUND' $ upper(COMMENT)
					lnRecno = recno()
					dimension This.aForeground[lnRecno]
					This.aForeground[lnRecno] = createobject('Empty')
				endscan for 'FOREGROUND' $ upper(COMMENT)
				if between(lnCurrRecno, 1, reccount())
					go lnCurrRecno
				endif between(lnCurrRecno, 1, reccount())
				select (lnSelect)
				set datasession to lnSession

* If we're rendering an object that's supposed to be in the foreground, save
* the rendering information.

			case not This.lSelfCall and tcMethodToken = 'RENDER' and ;
				vartype(This.aForeground[tP1]) = 'O'
				loForeground = This.aForeground[tP1]
				addproperty(loForeground, 'FRXRecno', tP1)
				addproperty(loForeground, 'Left',     tP2)
				addproperty(loForeground, 'Top',      tP3)
				addproperty(loForeground, 'Width',    tP4)
				addproperty(loForeground, 'Height',   tP5)
				addproperty(loForeground, 'ContType', tP6)
				addproperty(loForeground, 'Contents', tP7)
				addproperty(loForeground, 'Image',    tP8)
				lnReturn = 2 && OUTPUTFX_BASERENDER_NORENDER

* If we're about to do the page footer band, render all foreground objects.

			case tcMethodToken = 'BEFOREBAND' and tP1 = 7 && FRX_OBJCOD_PAGEFOOTER
				for lnI = 1 to alen(This.aForeground)
					loForeground = This.aForeground[lnI]
					if vartype(loForeground) = 'O'
						This.lSelfCall = .T.
						toListener.Render(loForeground.FRXRecno, loForeground.Left, ;
							loForeground.Top, loForeground.Width, loForeground.Height, ;
							loForeground.ContType, loForeground.Contents, ;
							loForeground.Image)
						This.lSelfCall = .F.
					endif vartype(loForeground) = 'O'
				next lnI
		endcase
		return lnReturn
	endfunc
enddefine
